org.apache.xpath

## Class SourceTreeManager

- java.lang.Object
- - org.apache.xpath.SourceTreeManager

-     public class SourceTreeManager
      extends java.lang.Object

  This class bottlenecks all management of source trees. The methods in this class should allow easy garbage collection of source trees (not yet!), and should centralize parsing for those source trees.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `SourceTreeManager()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `findURIFromDoc(int owner)` Given a document, find the URL associated with that document.
    `int` | `getNode(javax.xml.transform.Source source)` Given a Source object, find the node associated with it.
    `int` | `getSourceTree(javax.xml.transform.Source source, javax.xml.transform.SourceLocator locator, XPathContext xctxt)` Get the source tree from the input source.
    `int` | `getSourceTree(java.lang.String base, java.lang.String urlString, javax.xml.transform.SourceLocator locator, XPathContext xctxt)` Get the source tree from the a base URL and a URL string.
    `javax.xml.transform.URIResolver` | `getURIResolver()` Get the object that will be used to resolve URIs used in document(), etc.
    `static org.xml.sax.XMLReader` | `getXMLReader(javax.xml.transform.Source inputSource, javax.xml.transform.SourceLocator locator)` This method returns the SAX2 parser to use with the InputSource obtained from this URI.
    `int` | `parseToNode(javax.xml.transform.Source source, javax.xml.transform.SourceLocator locator, XPathContext xctxt)` Try to create a DOM source tree from the input source.
    `void` | `putDocumentInCache(int n, javax.xml.transform.Source source)` Put the source tree root node in the document cache.
    `void` | `removeDocumentFromCache(int n)` JJK: Support
    `void` | `reset()` Reset the list of SourceTree objects that this manager manages.
    `javax.xml.transform.Source` | `resolveURI(java.lang.String base, java.lang.String urlString, javax.xml.transform.SourceLocator locator)` This will be called by the processor when it encounters an xsl:include, xsl:import, or document() function.
    `void` | `setURIResolver(javax.xml.transform.URIResolver resolver)` Set an object that will be used to resolve URIs used in document(), etc.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SourceTreeManager

          public SourceTreeManager()

  - ### Method Detail

    - #### reset

          public void reset()

      Reset the list of SourceTree objects that this manager manages.

    - #### setURIResolver

          public void setURIResolver(javax.xml.transform.URIResolver resolver)

      Set an object that will be used to resolve URIs used in document(), etc.
      Parameters:
        `resolver` - An object that implements the URIResolver interface, or null.

    - #### getURIResolver

          public javax.xml.transform.URIResolver getURIResolver()

      Get the object that will be used to resolve URIs used in document(), etc.
      Returns:
        An object that implements the URIResolver interface, or null.

    - #### findURIFromDoc

          public java.lang.String findURIFromDoc(int owner)

      Given a document, find the URL associated with that document.
      Parameters:
        `owner` - Document that was previously processed by this liaison.
      Returns:
        The base URI of the owner argument.

    - #### resolveURI

          public javax.xml.transform.Source resolveURI(java.lang.String base,
                                                       java.lang.String urlString,
                                                       javax.xml.transform.SourceLocator locator)
                                                throws javax.xml.transform.TransformerException,
                                                       java.io.IOException

      This will be called by the processor when it encounters an xsl:include, xsl:import, or document() function.
      Parameters:
        `base` - The base URI that should be used.
        `urlString` - Value from an xsl:import or xsl:include's href attribute, or a URI specified in the document() function.
      Returns:
        a Source that can be used to process the resource.
      Throws:
        `java.io.IOException`
        `javax.xml.transform.TransformerException`

    - #### removeDocumentFromCache

          public void removeDocumentFromCache(int n)

      JJK: Support kluge in ElemForEach. TODO: This function is highly dangerous. Cache management must be improved.
      Parameters:
        `n` - The node to remove.

    - #### putDocumentInCache

          public void putDocumentInCache(int n,
                                         javax.xml.transform.Source source)

      Put the source tree root node in the document cache. TODO: This function needs to be a LOT more sophisticated.
      Parameters:
        `n` - The node to cache.
        `source` - The Source object to cache.

    - #### getNode

          public int getNode(javax.xml.transform.Source source)

      Given a Source object, find the node associated with it.
      Parameters:
        `source` - The Source object to act as the key.
      Returns:
        The node that is associated with the Source, or null if not found.

    - #### getSourceTree

          public int getSourceTree(java.lang.String base,
                                   java.lang.String urlString,
                                   javax.xml.transform.SourceLocator locator,
                                   XPathContext xctxt)
                            throws javax.xml.transform.TransformerException

      Get the source tree from the a base URL and a URL string.
      Parameters:
        `base` - The base URI to use if the urlString is relative.
        `urlString` - An absolute or relative URL string.
        `locator` - The location of the caller, for diagnostic purposes.
      Returns:
        should be a non-null reference to the node identified by the base and urlString.
      Throws:
        `javax.xml.transform.TransformerException` - If the URL can not resolve to a node.

    - #### getSourceTree

          public int getSourceTree(javax.xml.transform.Source source,
                                   javax.xml.transform.SourceLocator locator,
                                   XPathContext xctxt)
                            throws javax.xml.transform.TransformerException

      Get the source tree from the input source.
      Parameters:
        `source` - The Source object that should identify the desired node.
        `locator` - The location of the caller, for diagnostic purposes.
      Returns:
        non-null reference to a node.
      Throws:
        `javax.xml.transform.TransformerException` - if the Source argument can't be resolved to a node.

    - #### parseToNode

          public int parseToNode(javax.xml.transform.Source source,
                                 javax.xml.transform.SourceLocator locator,
                                 XPathContext xctxt)
                          throws javax.xml.transform.TransformerException

      Try to create a DOM source tree from the input source.
      Parameters:
        `source` - The Source object that identifies the source node.
        `locator` - The location of the caller, for diagnostic purposes.
      Returns:
        non-null reference to node identified by the source argument.
      Throws:
        `javax.xml.transform.TransformerException` - if the source argument can not be resolved to a source node.

    - #### getXMLReader

          public static org.xml.sax.XMLReader getXMLReader(javax.xml.transform.Source inputSource,
                                                           javax.xml.transform.SourceLocator locator)
                                                    throws javax.xml.transform.TransformerException

      This method returns the SAX2 parser to use with the InputSource obtained from this URI. It may return null if any SAX2-conformant XML parser can be used, or if getInputSource() will also return null. The parser must be free for use (i.e. not currently in use for another parse().
      Parameters:
        `inputSource` - The value returned from the URIResolver.
        `locator` - The location of the original caller, for diagnostic purposes.
      Returns:
        a SAX2 XMLReader to use to resolve the inputSource argument.
      Throws:
        `javax.xml.transform.TransformerException` - if the reader can not be created.

Copyright © 2023 Apache XML Project. All Rights Reserved.